#!/bin/sh

MMBLANCONF_FILEPATH=$1
SECTION=""

CHKFIN_NET="no"
CHKFIN_PAR="no"
CHKFIN_MMBIP="no"
CHKFIN_ID="no"

IPV4="^(([0-9]|[1-9][0-9]|1[0-9]{2}|2[0-4][0-9]|25[0-5])\\.){3}([0-9]|[1-9][0-9]|1[0-9]{2}|2[0-4][0-9]|25[0-5])$"
PARID="^[0-3]$"

IFS='
'
for LINE in `grep -v -P "^;|^[[:blank:]]*$" $MMBLANCONF_FILEPATH`
  do
  echo $LINE | grep -P "^\[.*\]$" > /dev/null 2>&1
  if [ $? -eq 0 ] ; then
	  SEC_VAL="`echo $LINE | sed \"s/\[\(.*\)\]$/\1/\"`"
	  if [ "$SEC_VAL" = "NETWORK" ] ; then
		  if [ "$CHKFIN_NET" = "yes" ] ; then
			  ### multi definition
			  exit 1
		  fi
		  SECTION="NETWORK"
		  CHKFIN_NET="yes"
		  continue
	  elif [ "$SEC_VAL" = "PARTITION" ] ; then
		  if [ "$CHKFIN_PAR" = "yes" ] ; then
			  ### multi definition
			  exit 2
		  fi
		  SECTION="PARTITION"
		  CHKFIN_PAR="yes"
		  continue
	  else
		  SECTION=""
		  continue
	  fi
  fi

  if [ "$SECTION" = "NETWORK" ] ; then
	  echo $LINE | grep -P "^[[:blank:]]*MMBIP[[:blank:]]*=" > /dev/null 2>&1
	  if [ $? -eq 0 ] ; then
		  if [ "$CHKFIN_MMBIP" = "yes" ] ; then
			  ### multi definition
			  exit 5
		  fi
		  echo $LINE | sed "s/.*MMBIP[[:blank:]]*=[[:blank:]]*\(.*\)$/\1/" | egrep $IPV4 > /dev/null 2>&1
		  if [ $? -ne 0 ] ; then
			  ### format error
			  exit 6
		  fi
		  CHKFIN_MMBIP="yes"
		  continue
	  fi
  elif [ "$SECTION" = "PARTITION" ] ; then
	  echo $LINE | grep -P "^[[:blank:]]*ID[[:blank:]]*=" > /dev/null 2>&1
	  if [ $? -eq 0 ] ; then
		  if [ "$CHKFIN_ID" = "yes" ] ; then
			  ### multi definition
			  exit 7
		  fi
		  echo $LINE | sed "s/.*ID[[:blank:]]*=[[:blank:]]*\(.*\)$/\1/" | egrep $PARID > /dev/null 2>&1
		  if [ $? -ne 0 ] ; then
			  ### format error
			  exit 8
		  fi
		  CHKFIN_ID="yes"
		  continue
	  fi
  fi
done

### error check
if [ "$CHKFIN_MMBIP" = "no" -o "$CHKFIN_ID" = "no" ] ; then
	### some value wasn't checked yet
	if [ "$CHKFIN_NET" = "no" -a "$CHKFIN_PAR" = "no" ] ; then
		exit 9
	elif [ "$CHKFIN_NET" = "no" ] ; then
		exit 10
	elif [ "$CHKFIN_PAR" = "no" ] ; then
		exit 11
	fi

	if [ "$CHKFIN_MMBIP" = "no" -a "$CHKFIN_ID" = "no" ] ; then
		exit 15
	elif [ "$CHKFIN_MMBIP" = "no" ] ; then
		exit 17
	elif [ "$CHKFIN_ID" = "no" ] ; then
		exit 18
	fi
fi

exit 0