#!/bin/sh
# $Id: gethostinfo.sh,v 1.9 2014/07/02 02:43:00 sato Exp $
# $Name: SLINSVMCOVM-1_6_0-0 $

if [ $# -ne 4 ] ; then
    exit 2
fi

SSH_OPT1="StrictHostKeyChecking no"
SSH_OPT2="NumberOfPasswordPrompts 1"
ESXI_PROMPT="#"
PW_PROMPT="word:"
WAIT_TIME=1
RETRY_COUNT=3

if [ "$1" = "a" -o  "$1" = "p" ] ; then
    rm -f /var/fujitsu/SVmco/log/svfs/pcicardinfo_org
    expect -c "
    set timeout 5
    spawn ssh -o \"$SSH_OPT1\" -o \"$SSH_OPT2\" $3@$2 /sbin/esxcli hardware pci list > /scratch/pcicardinfo_org
    expect $PW_PROMPT ; send \"$4\r\"
    expect $ESXI_PROMPT
    " >/dev/null 2>&1
    expect -c "
    set timeout 5
    spawn scp -o \"$SSH_OPT1\" -o \"$SSH_OPT2\" $3@$2:/scratch/pcicardinfo_org /var/fujitsu/SVmco/log/svfs/pcicardinfo_org
    expect $PW_PROMPT ; send \"$4\r\"
    expect $ESXI_PROMPT
    " >/dev/null 2>&1
    if [ ! -f /var/fujitsu/SVmco/log/svfs/pcicardinfo_org ] ; then
        exit 2
    fi
fi

if [ "$1" = "a" -o  "$1" = "l" ] ; then
    rm -f /var/fujitsu/SVmco/work/cmd/vmkernel.log
    expect -c "
    set timeout 5
    spawn scp -o \"$SSH_OPT1\" -o \"$SSH_OPT2\" $3@$2:/var/log/vmkernel.log /var/fujitsu/SVmco/work/cmd/vmkernel.log
    expect $PW_PROMPT ; send \"$4\r\"
    expect $ESXI_PROMPT
    " >/dev/null 2>&1
    if [ ! -f /var/fujitsu/SVmco/work/cmd/vmkernel.log ] ; then
        exit 2
    fi
fi

if [ "$1" = "a" -o  "$1" = "n" ] ; then
    rm -f /var/fujitsu/SVmco/log/svfs/nicinfo_org
    expect -c "
    set timeout 5
    spawn ssh -o \"$SSH_OPT1\" -o \"$SSH_OPT2\" $3@$2 /sbin/esxcfg-nics -l > /scratch/nicinfo_org
    expect $PW_PROMPT ; send \"$4\r\"
    expect $ESXI_PROMPT
    " >/dev/null 2>&1
    expect -c "
    set timeout 5
    spawn scp -o \"$SSH_OPT1\" -o \"$SSH_OPT2\" $3@$2:/scratch/nicinfo_org /var/fujitsu/SVmco/log/svfs/nicinfo_org
    expect $PW_PROMPT ; send \"$4\r\"
    expect $ESXI_PROMPT
    " >/dev/null 2>&1
    if [ ! -f /var/fujitsu/SVmco/log/svfs/nicinfo_org ] ; then
        exit 2
    fi
fi

if [ "$1" = "a" -o  "$1" = "h" ] ; then
    rm -f /var/fujitsu/SVmco/log/svfs/vmkmgmt_keyval_org
    expect -c "
    set timeout 5
    spawn ssh -o \"$SSH_OPT1\" -o \"$SSH_OPT2\" $3@$2 /usr/lib/vmware/vmkmgmt_keyval/vmkmgmt_keyval -a > /scratch/vmkmgmt_keyval_org
    expect $PW_PROMPT ; send \"$4\r\"
    expect $ESXI_PROMPT
    " >/dev/null 2>&1
    expect -c "
    set timeout 5
    spawn scp -o \"$SSH_OPT1\" -o \"$SSH_OPT2\" $3@$2:/scratch/vmkmgmt_keyval_org /var/fujitsu/SVmco/log/svfs/vmkmgmt_keyval_org
    expect $PW_PROMPT ; send \"$4\r\"
    expect $ESXI_PROMPT
    " >/dev/null 2>&1
    if [ ! -f /var/fujitsu/SVmco/log/svfs/vmkmgmt_keyval_org ] ; then
        exit 2
    fi
fi

if [ "$1" = "a" -o  "$1" = "h" ] ; then
    rm -f /var/fujitsu/SVmco/log/svfs/esxcfg-scsidevs_org
    expect -c "
    set timeout 5
    spawn ssh -o \"$SSH_OPT1\" -o \"$SSH_OPT2\" $3@$2 esxcfg-scsidevs -a > /scratch/esxcfg-scsidevs_org
    expect $PW_PROMPT ; send \"$4\r\"
    expect $ESXI_PROMPT
    " >/dev/null 2>&1
    expect -c "
    set timeout 5
    spawn scp -o \"$SSH_OPT1\" -o \"$SSH_OPT2\" $3@$2:/scratch/esxcfg-scsidevs_org /var/fujitsu/SVmco/log/svfs/esxcfg-scsidevs_org
    expect $PW_PROMPT ; send \"$4\r\"
    expect $ESXI_PROMPT
    " >/dev/null 2>&1
    if [ ! -f /var/fujitsu/SVmco/log/svfs/esxcfg-scsidevs_org ] ; then
        exit 2
    fi
fi

if [ "$1" = "r" ] ; then
    expect -c "
    set timeout 5
    spawn scp -o \"$SSH_OPT1\" -o \"$SSH_OPT2\" /opt/fujitsu/SVmco/bin/IPMISetSystemStatus $3@$2:/scratch/IPMISetSystemStatus
    expect $PW_PROMPT ; send \"$4\r\"
    expect $ESXI_PROMPT
    " >/dev/null 2>&1
    for var1 in `seq 0 $RETRY_COUNT`
    do
        rm -f /var/fujitsu/SVmco/work/cmd/Result
        expect -c "
        set timeout 5
        spawn ssh -o \"$SSH_OPT1\" -o \"$SSH_OPT2\" $3@$2 /scratch/IPMISetSystemStatus R >/scratch/Result 2>&1
        expect $PW_PROMPT ; send \"$4\r\"
        expect $ESXI_PROMPT
        " >/dev/null 2>&1
        expect -c "
        set timeout 5
        spawn scp -o \"$SSH_OPT1\" -o \"$SSH_OPT2\" $3@$2:/scratch/Result /var/fujitsu/SVmco/work/cmd/Result
        expect $PW_PROMPT ; send \"$4\r\"
        expect $ESXI_PROMPT
        " >/dev/null 2>&1
        if [ -f /var/fujitsu/SVmco/work/cmd/Result ] ; then
            if [ `cat /var/fujitsu/SVmco/work/cmd/Result` -eq 0 ] ; then
                exit 0
            fi
        fi
        sleep $WAIT_TIME
    done
    if [ -f /var/fujitsu/SVmco/work/cmd/Result ] ; then
        exit `cat /var/fujitsu/SVmco/work/cmd/Result`
    else
        exit 2
    fi
fi

if [ "$1" = "s" ] ; then
    rm -f /var/fujitsu/SVmco/work/cmd/Result
    expect -c "
    set timeout 5
    spawn scp -o \"$SSH_OPT1\" -o \"$SSH_OPT2\" /opt/fujitsu/SVmco/bin/IPMISetSystemStatus $3@$2:/scratch/IPMISetSystemStatus
    expect $PW_PROMPT ; send \"$4\r\"
    expect $ESXI_PROMPT
    " >/dev/null 2>&1
    expect -c "
    set timeout 5
    spawn ssh -o \"$SSH_OPT1\" -o \"$SSH_OPT2\" $3@$2 /scratch/IPMISetSystemStatus S >/scratch/Result 2>&1
    expect $PW_PROMPT ; send \"$4\r\"
    expect $ESXI_PROMPT
    " >/dev/null 2>&1
    expect -c "
    set timeout 5
    spawn scp -o \"$SSH_OPT1\" -o \"$SSH_OPT2\" $3@$2:/scratch/Result /var/fujitsu/SVmco/work/cmd/Result
    expect $PW_PROMPT ; send \"$4\r\"
    expect $ESXI_PROMPT
    " >/dev/null 2>&1
    if [ ! -f /var/fujitsu/SVmco/work/cmd/Result ] ; then
        exit 2
    fi
    exit `cat /var/fujitsu/SVmco/work/cmd/Result`
fi

exit 0
