#include <cimc.h>
#include <cmci.h>
#include <native.h>
#include <unistd.h>
#include <stdlib.h>
#include "cmcimacs.h"

extern char *value2Chars(CMPIType type, CMPIValue * value);
void showProperty( CMPIData , char * );
void showInstance( CMPIInstance * );
static char * CMPIState_str(CMPIValueState);

void usage(void){
  printf("Usage: v2test_ei <ESXi Host IPv4 address> <Login ID> <Login PASSWORD> <cim name space> <cim class name>\n");
}

int main( int argc, char *argv[] )
{
  CIMCEnv *ce;
  char *msg = NULL;
  int rc;

  CIMCStatus status;
  CMPIObjectPath *op = NULL ;
  CIMCEnumeration *enm = NULL;
  CIMCClient *client = NULL;
  CIMCData data;
  int count = 0;
  int result = 0;

  char * cim_host_cert;
  
  cim_host_cert = getenv("CIM_HOST_CERT");

    if( argc != 6 ){
      printf( "argument error.\n" );
      usage();
      return 10;
    }

  ce = NewCIMCEnv( "XML", 0, &rc, &msg );

  if(ce == NULL) {
    printf(" local connect failed call to NewCIMCEnv message = [%s] \n",msg) ;
    return 20;
  }
    
  client = 
    ce->ft->connect2( ce,
		      argv[1],
		      "https",
		      "5989",
		      argv[2],
		      argv[3],
		      CMCI_VERIFY_NONE,
		      cim_host_cert,
		      NULL,
		      NULL,
		      &status );
  if(client == NULL) 
    {
      printf(" failed the call to connect \n") ;
      result = 30;
    }else{
    
    op =
      (CMPIObjectPath *) ce->ft->newObjectPath( ce,
						argv[4],
						argv[5],
						&status );
    if(op == NULL) 
      {
      printf(" failed the call to newObjectPath \n") ;	
      result = 40;
      }else {
    
      enm =
	client->ft->enumInstances( client,
				   (CIMCObjectPath *) op,
				   0,
				   NULL,
				   &status );
      
      if(enm == NULL) 
	{
	  printf(" failed the call to client->ft->enumInstances \n") ;	
	}
      
      /* Print the results */
      
      if (!status.rc) {
	printf("results:\n");
	count = enm->ft->hasNext(enm, NULL) ;
	while (count > 0) {
	  
	  data = enm->ft->getNext(enm, NULL);
	  
	  showInstance( (CMPIInstance *)data.value.inst );
	  /*
	   * see if we have any more
	   */
	  count = enm->ft->hasNext(enm, NULL) ;   
	}
	result = status.rc;
      } else {
	printf("  ERROR received from enumInstances status.rc = %d\n",status.rc) ;
	if(msg)
	  printf("  ERROR msg = %s\n",msg) ;
	result = status.rc;
      }
    }
  }

  if(enm) enm->ft->release(enm);
  if(op) op->ft->release(op);
  if(client) client->ft->release(client);
  if(ce) ce->ft->release(ce);
  if(status.msg) CMRelease(status.msg);		       

  return result;

}
